
// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_AccessTypeDefinition.hh"
#include "savant.hh"
#include <iostream>
using std::cerr;

IIRBase_AccessTypeDefinition::IIRBase_AccessTypeDefinition(){
  set_designated_type( NULL );
}

IIRBase_AccessTypeDefinition::~IIRBase_AccessTypeDefinition(){
  delete get_designated_type();
}

IIR_AccessTypeDefinition *
IIRBase_AccessTypeDefinition::get( IIR_TypeDefinition * ){
  cerr << "IIRBase_AccessTypeDefinition::get not yet implemented!\n";
  abort();
  return NULL;
}

void 
IIRBase_AccessTypeDefinition::set_designated_type( IIR_TypeDefinition *designated_type){
  access_for_type = designated_type;
}


IIR_TypeDefinition *
IIRBase_AccessTypeDefinition::get_designated_type(){
  return access_for_type;
}
