
// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_ExitStatement.hh"
#include "savant.hh"

IIRBase_ExitStatement::IIRBase_ExitStatement(){
  set_enclosing_loop( NULL );
  set_condition( NULL );
}

IIRBase_ExitStatement::~IIRBase_ExitStatement(){
  
}

void 
IIRBase_ExitStatement::set_enclosing_loop( IIR_SequentialStatement *enclosing_loop ){
  this->enclosing_loop = enclosing_loop;
}

IIR_SequentialStatement *
IIRBase_ExitStatement::get_enclosing_loop(){
  return enclosing_loop;
}

void 
IIRBase_ExitStatement::set_condition( IIR *condition ){
  this->condition = condition;
}

IIR *
IIRBase_ExitStatement::get_condition(){
  return condition;
}
