
// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_FunctionDeclaration.hh"
#include "savant.hh"

IIRBase_FunctionDeclaration::IIRBase_FunctionDeclaration() {
  set_return_type(NULL);
  set_pure(IIR_PURE_FUNCTION);
}

IIRBase_FunctionDeclaration::~IIRBase_FunctionDeclaration() {}

void
IIRBase_FunctionDeclaration::set_pure( IIR_Pure new_purity ){
  purity = new_purity;
}

IIR_Pure
IIRBase_FunctionDeclaration::get_pure() {
  return purity;
}

void
IIRBase_FunctionDeclaration::set_return_type( IIR_TypeDefinition *new_return_type ){
  return_type = new_return_type;
}

IIR_TypeDefinition*
IIRBase_FunctionDeclaration::get_return_type() {
  return return_type;
}
