// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_IfStatement.hh"
#include "IIR_Elsif.hh"
#include "savant.hh"

IIRBase_IfStatement::IIRBase_IfStatement() {
  set_condition(NULL);
  set_elsif(NULL);
}


IIRBase_IfStatement::~IIRBase_IfStatement() {
  if (condition != NULL) { delete condition; }
  if (elsif_clause != NULL) { delete elsif_clause; }
}


void
IIRBase_IfStatement::set_condition(IIR* condition) {
  this->condition = condition;
}


IIR*
IIRBase_IfStatement::get_condition() {
  return condition;
}


void
IIRBase_IfStatement::set_elsif(IIR_Elsif* elsif_clause) {
  this->elsif_clause = elsif_clause;
}


IIR_Elsif*
IIRBase_IfStatement::get_elsif() {
  return elsif_clause;
}
