
// Copyright (c) 1996-1999 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_SignalDeclaration.hh"
#include "savant.hh"

IIRBase_SignalDeclaration::IIRBase_SignalDeclaration() {
  set_value(NULL);
  set_signal_kind(IIR_NO_SIGNAL_KIND);
}

IIRBase_SignalDeclaration::~IIRBase_SignalDeclaration() {}

void
IIRBase_SignalDeclaration::set_value( IIR *new_value ){
  value = new_value;
}

IIR*
IIRBase_SignalDeclaration::get_value() {
  return value;
}

void
IIRBase_SignalDeclaration::set_signal_kind( IIR_SignalKind new_signal_kind ){
  signal_kind = new_signal_kind;
}

IIR_SignalKind
IIRBase_SignalDeclaration::get_signal_kind() {
  return signal_kind;
}

