
#ifndef IIRSCRAM_CASE_STATEMENT_ALTERNATIVE_LIST_HH
#define IIRSCRAM_CASE_STATEMENT_ALTERNATIVE_LIST_HH

// Copyright (c) 1996-2002 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
// SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
// OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
// LICENSEE AS A RESULT OF USING, RESULT OF USING, MODIFYING OR
// DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the U.S.,
// and the terms of this license.

// You may modify, distribute, and use the software contained in this
// package under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE"
// version 2, June 1991. A copy of this license agreement can be found in
// the file "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@cliftonlabs.com
//          Timothy J. McBrayer
//          Malolan Chetlur

//---------------------------------------------------------------------------

#include "IIRBase_CaseStatementAlternativeList.hh"
class IIRScram_WaitStatement;

class IIRScram_CaseStatementAlternativeList : public IIRBase_CaseStatementAlternativeList {

public:
  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);

  void _publish_cc( published_file &_cc_out );
  void _publish_cc_decl_for_loop_iterator( published_file &_cc_out );
  void _build_wait_list(dl_list<IIRScram_WaitStatement>* );
  void _get_list_of_input_signals( set<IIR> *list );
  void _get_signal_source_info( set<IIR> *siginfo );

protected:
  IIRScram_CaseStatementAlternativeList() {}
  virtual ~IIRScram_CaseStatementAlternativeList() = 0;
    
private:

};

#endif
