
#ifndef IIRSCRAM_CONDITIONAL_WAVEFORM_HH
#define IIRSCRAM_CONDITIONAL_WAVEFORM_HH

// Copyright (c) 1996-2000 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_ConditionalWaveform.hh"
template <class type> class set;
class IIR_TypeDefinition;
class IIR_DesigantorList;
class IIR_List;

class IIRScram_ConditionalWaveform : public IIRBase_ConditionalWaveform {

public:

  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);


  void _publish_vhdl(ostream &);
  void _type_check( set<IIR_TypeDefinition> * );
  set<IIR_TypeDefinition> *_get_rval_set(IIR_Boolean (IIR::*constraint_function)()=0); 
  IIR *_rval_to_decl( IIR_TypeDefinition * );
  IIR *_semantic_transform( set<IIR_TypeDefinition> * );
  void _build_sensitivity_list(IIR_DesignatorList* sensitivity_list);
  ostream &_print( ostream & );
 
  IIR_Boolean _is_resolved();

protected:
  
  IIRScram_ConditionalWaveform() {};
  virtual ~IIRScram_ConditionalWaveform() = 0;
    
private:
  

};

#endif
