#ifndef IIRSCRAM_ELEMENT_DECLARATION_HH
#define IIRSCRAM_ELEMENT_DECLARATION_HH
// Copyright (c) 1996-2000 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu
//          Radharamanan Radhakrishnan  ramanan@ece.uc.edu

//---------------------------------------------------------------------------
#include "IIRBase_ElementDeclaration.hh"
class IIR_Name;
class IIR_List ;

class IIRScram_ElementDeclaration : public IIRBase_ElementDeclaration {

public:

  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);


  void _publish_vhdl_decl(ostream &);

  set<IIR_Declaration> *_find_declarations( IIR_Name *to_find );

  set<IIR_TypeDefinition> *_get_rval_set( set<IIR_TypeDefinition> *,
					  IIR_Boolean (IIR::*constraint_function)() = 0 );

  set<IIR_TypeDefinition> *_get_rval_set( set<IIR_Declaration> *,
					  IIR_Boolean (IIR::*constraint_function)() = 0 ); 

  IIR_TypeDefinition *_determine_rval_in_set( set<IIR_TypeDefinition> *, IIR_TypeDefinition * );

  IIR *_rval_to_decl( IIR_TypeDefinition *prefix_rval, IIR_TypeDefinition *suffix_rval );

  void _publish_cc_lvalue( published_file &_cc_out );
  void _publish_cc_universal_value( published_file &_cc_out );
  int _get_field_number();
  void _publish_cc_elaborate( published_file &_cc_out );
  void _publish_cc_include( published_file &_cc_out );

  declaration_type _get_type(){ return ELEMENT; }
  IIR_Boolean _is_element(){ return TRUE; }
  IIR_Boolean _is_iir_element_declaration(){ return TRUE; }

  IIR_TypeDefinition *_get_type_of_element( int );

protected:
  IIRScram_ElementDeclaration() {}
  virtual ~IIRScram_ElementDeclaration() = 0;
    
private:
};
#endif
