
#ifndef IIRSCRAM_FOR_LOOP_STATEMENT_HH
#define IIRSCRAM_FOR_LOOP_STATEMENT_HH

// Copyright (c) 1996-2003 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
// SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
// OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
// LICENSEE AS A RESULT OF USING, RESULT OF USING, MODIFYING OR
// DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the U.S.,
// and the terms of this license.

// You may modify, distribute, and use the software contained in this
// package under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE"
// version 2, June 1991. A copy of this license agreement can be found in
// the file "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	philip.wilsey@ieee.org
//          Dale E. Martin	dmartin@cliftonlabs.com
//          Timothy J. McBrayer 
//          Malolan Chetlur     
//          Umesh Kumar V. Rajasekaran
//          Krishnan Subramani  

#include "IIRBase_ForLoopStatement.hh"

class IIR_DesignatorList;
class IIR_TypeDefinition;
template <class type> class set;
class IIR_List;
class IIR_Attribute;
class IIR_AboveAttribute;

class IIRScram_ForLoopStatement : public IIRBase_ForLoopStatement {
public:
  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);

  void _publish_vhdl(ostream &);

  void _publish_cc( published_file &_cc_out );
  void _publish_cc_decl_for_loop_iterator( published_file &_cc_out );

  void _type_check();
  void _build_wait_list(dl_list<IIRScram_WaitStatement>* );
  void _build_procedure_call_stmt_list(dl_list<IIR_ProcedureCallStatement> *);
  void _get_list_of_input_signals( set<IIR> *list);
  void _get_signal_source_info( set<IIR> *siginfo );
  IIR_Boolean _type_check_return_statements( set<IIR_TypeDefinition> *,
					     IIR_SubprogramDeclaration *subprogram_decl );

  set<IIR_Declaration> *_find_declarations( IIR_Name * );
  
  IIR_Boolean _has_statement_list(){
    return TRUE;
  }

  void _publish_cc_attr_of_range_attribute( published_file &_cc_out, 
					    const char *, 
					    IIR_Attribute * );

  void _publish_cc_ascending_of_range_attribute( published_file &_cc_out,
						 IIR_Attribute *range_attr);
  
  void _publish_cc_high_of_range_attribute( published_file &_cc_out, 
					    IIR_Attribute *range_attr);

  void _publish_cc_low_of_range_attribute( published_file &_cc_out, 
					   IIR_Attribute* range_attr);

  IIR_Boolean _is_above_attribute_found();
  void _build_above_attribute_set(set<IIR_AboveAttribute> *);
  
protected:
  IIRScram_ForLoopStatement() {
  }

  virtual ~IIRScram_ForLoopStatement() = 0;
    
private:
};
#endif
