// Copyright (c) 1996-2000 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRScram_IdentityOperator.hh"
#include "savant.hh"

IIRScram_IdentityOperator::~IIRScram_IdentityOperator() {}

void 
IIRScram_IdentityOperator::_publish_vhdl_operator(ostream &_vhdl_out) {
  _vhdl_out << "+";
}

const string &
IIRScram_IdentityOperator::_get_cc_operator_name() const {
  static const string operator_name = "vhdlUnaryPlus";
  return operator_name;
}

IIR_TypeDefinition * 
IIRScram_IdentityOperator::get_subtype(){
  ASSERT( get_operand()->_is_resolved() == TRUE );
  return get_operand()->get_subtype();
}

IIRScram::OperatorPrecedenceLevel
IIRScram_IdentityOperator::_get_operator_precedence(){
  return IIRScram::SIGN_OPERATOR;
}

visitor_return_type *IIRScram_IdentityOperator::_accept_visitor(node_visitor *visitor, visitor_argument_type *arg) {
  ASSERT(visitor != NULL);
  return visitor->visit_IIR_IdentityOperator(this, arg);
};
