
#ifndef IIRSCRAM_PHYSICAL_TYPE_DEFINITION_HH
#define IIRSCRAM_PHYSICAL_TYPE_DEFINITION_HH

// Copyright (c) 1996-2000 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Umesh Kumar V. Rajasekaran urajasek@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu
//          Krishnan Subramani  skrish@ece.uc.edu

//---------------------------------------------------------------------------

#include "IIRBase_PhysicalTypeDefinition.hh"

class IIR_PhysicalTypeDefinition;

class IIRScram_PhysicalTypeDefinition : public IIRBase_PhysicalTypeDefinition {

public:

  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);

  IIR_Boolean _is_numeric_type() { return TRUE; }
  IIR_Boolean _is_physical_type() { return TRUE; }
  IIR_Boolean _is_iir_physical_type_definition() { return TRUE; }

  void _publish_vhdl_type_decl(ostream &);

  bool _is_time();
  void _publish_cc_elaborate( published_file &_cc_out );
  void _publish_cc_left( published_file &_cc_out );
  void _publish_cc_right( published_file &_cc_out );
  void _publish_cc_universal_type( published_file &_cc_out );

  const string _get_cc_kernel_type();

  void _publish_cc_data_members( published_file &_cc_out );
  void _publish_cc_decl_cc( published_file &_cc_out );

  void _publish_cc_multiply_operator_prototype( published_file &_cc_out );
  void _publish_cc_divide_operator_prototype( published_file &_cc_out );

  void _publish_cc_multiply_operator( published_file &_cc_out );
  void _publish_cc_divide_operator( published_file &_cc_out );

  void _publish_cc_type_info( published_file &_cc_out );
  void _publish_cc_extern_type_info( published_file &_cc_out );
  void _publish_cc_type_string( published_file &_cc_out );
  
  virtual IIR_TypeDefinition *_get_new_subtype();
  virtual IIR *_clone();
  virtual void _clone( IIR * );
  virtual IIR_TypeDefinition *_construct_new_subtype( IIR_Name *resolution_function,
						      IIR_ScalarTypeDefinition *new_constraint);

  void _set_resolution_function( IIR_FunctionDeclaration * );

protected:
  
  IIRScram_PhysicalTypeDefinition() {};
  virtual ~IIRScram_PhysicalTypeDefinition() = 0;

  void _build_implicit_operators( set<IIR_Declaration> * );
    
private:
 
};

#endif
