
#ifndef IIRSCRAM_SCALAR_NATURE_DEFINITION_HH
#define IIRSCRAM_SCALAR_NATURE_DEFINITION_HH

// Copyright (c) 2002-2003 The University of Cincinnati.  All rights
// reserved.
 
// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
// SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
// NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY
// LICENSEE AS A RESULT OF USING, RESULT OF USING, MODIFYING OR DISTRIBUTING
// THIS SOFTWARE OR ITS DERIVATIVES.
 
// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the U.S., and
// the terms of this license.
 
// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2, June
// 1991. A copy of this license agreement can be found in the file "LGPL",
// distributed with this archive.
 
// Authors: Sivakumar Gowrisankar             gowriss@ececs.uc.edu
//          Vinod Chamarty                    chamarv@ececs.uc.edu
//          Vasudevan Shanmugasundaram
//          Kathiresan Nellayappan
 
//---------------------------------------------------------------------------

#include "IIRBase_ScalarNatureDefinition.hh"
#include "IIR_TypeDefinition.hh"

class IIRScram_ScalarNatureDefinition : public IIRBase_ScalarNatureDefinition {

public:
  /** This function publishes the vhdl for across and free type_mark declared 
      for a nature definition. */
  void _publish_vhdl_decl(ostream &);

  const string _get_cc_type_name();

  /** This function does a check whether nature type_marks resolve to floating 
      point types */
  void floating_point_type_check(IIR_TypeDefinition *);

protected:
  IIRScram_ScalarNatureDefinition() {};
  virtual ~IIRScram_ScalarNatureDefinition() = 0;

private:

};
#endif
