#ifndef IIRSCRAM_STRING_LITERAL_HH
#define IIRSCRAM_STRING_LITERAL_HH

// Copyright (c) 1996-2000 The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.


// You may modify, distribute, and use the software contained in this package
// under the terms of the "GNU LIBRARY GENERAL PUBLIC LICENSE" version 2,
// June 1991. A copy of this license agreement can be found in the file
// "LGPL", distributed with this archive.

// Authors: Philip A. Wilsey	phil.wilsey@uc.edu
//          Dale E. Martin	dmartin@ece.uc.edu
//          Timothy J. McBrayer tmcbraye@ece.uc.edu
//          Malolan Chetlur     mal@ece.uc.edu
//          Krishnan Subramani  skrish@ece.uc.edu
//          Narayanan Thondugulam nthondug@ece.uc.edu
//          Radharamanan Radhakrishnan  ramanan@ece.uc.edu

//---------------------------------------------------------------------------
#include "IIRBase_StringLiteral.hh"
template <class type> class set;

class IIRScram_StringLiteral : public IIRBase_StringLiteral {
public:

  /// Accept visitations \Ref{_accept_visitor}.
  visitor_return_type* _accept_visitor(node_visitor *, visitor_argument_type *);

  void _publish_cc_lvalue( published_file &_cc_out );
  void _publish_cc_string( published_file &_cc_out );
  virtual void _publish_cc_state_object_init( published_file &_cc_out );
  void _publish_cc_initialization_value( published_file &_cc_out );
  void _publish_cc_universal_value( published_file &_cc_out );
  void _publish_cc_condition( published_file &_cc_out );
  void _publish_cc_bounds( published_file &_cc_out );
  void _publish_cc_range( published_file &_cc_out );
  void _publish_cc_headers( published_file &_cc_out );

  void _publish_cc_without_quotes( published_file &_cc_out );
  void _publish_cc_function_name( published_file &_cc_out );

  /**
     Returns a function name for this string literal.  (Used for operator names).
  */
  const string _convert_function_name( IIR_Boolean _is_unary_operator = FALSE );
  void _publish_cc_variable_name( published_file &_cc_out );

  IIR_Boolean _is_string_literal(){ return TRUE; }
  IIR_Boolean _is_array_type(){ return TRUE; }

  void _type_check( set<IIR_TypeDefinition> * );

  set<IIR_TypeDefinition> *
  _get_rval_set( IIR_Boolean (IIR::*constraint_function)() = 0 );
  IIR *_clone();

protected:
  IIRScram_StringLiteral();
  virtual ~IIRScram_StringLiteral() = 0;

private:
};
#endif
